unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, memds, BufDataset, DB, Forms, Controls, Graphics, Dialogs,
  DBCtrls, DBGrids, StdCtrls;

type
  TDBNavigator = class(DBCtrls.TDBNavigator)
  protected
    procedure EditingChanged; override;
  end;
  
  
  { TForm1 }

  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  if not Fileexists(BufDataset1.FileName) then
    BufDataset1.CreateDataset
  else
    BufDataset1.Open;
end;

procedure TDBNavigator.EditingChanged;
begin
  inherited;
  if (Datasource <> nil) and (Datasource.Dataset <> nil) and 
     (DataSource.Dataset.BOF and Datasource.Dataset.EOF) then
  begin
    Buttons[nbEdit].Enabled := false;
    FocusableButtons[nbEdit].Enabled := false;
  end;
end;

end.

